/***********************************************************************************************************************
 *
 * blueMarine Metadata - open source media workflow
 * Copyright (C) 2007-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~metadata-src
 *
 **********************************************************************************************************************/
package it.tidalwave.metadata.spi;

import it.tidalwave.metadata.Metadata.StorageType;
import javax.annotation.Nonnull;

/*******************************************************************************
 *
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public abstract class MetadataItemSourceSinkSupport<Item> implements MetadataItemSink<Item>, MetadataItemSource<Item>
  {
    @Nonnull 
    private final Class<Item> itemClass;
    
    @Nonnull 
    private final String name;
    
    @Nonnull 
    private final StorageType type;

    /***************************************************************************
     *
     * 
     **************************************************************************/
    public MetadataItemSourceSinkSupport (@Nonnull final Class<Item> itemClass, 
                                          @Nonnull final String name, 
                                          @Nonnull final StorageType storageType) 
      {
        this.itemClass = itemClass;
        this.name = name;
        this.type = storageType;
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     * 
     **************************************************************************/
    @Nonnull 
    public final Class<Item> getItemClass()
      {
        return itemClass;
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     * 
     **************************************************************************/
    @Nonnull 
    public final String getName()
      {
        return name;
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     * 
     **************************************************************************/
    @Nonnull 
    public final StorageType getType()
      {
        return type;
      }
  }
